import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateStackInstancesInput, CreateStackInstancesOutput } from "../models/models_0";
import { deserializeAws_queryCreateStackInstancesCommand, serializeAws_queryCreateStackInstancesCommand, } from "../protocols/Aws_query";
var CreateStackInstancesCommand = (function (_super) {
    __extends(CreateStackInstancesCommand, _super);
    function CreateStackInstancesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateStackInstancesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "CreateStackInstancesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateStackInstancesInput.filterSensitiveLog,
            outputFilterSensitiveLog: CreateStackInstancesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateStackInstancesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCreateStackInstancesCommand(input, context);
    };
    CreateStackInstancesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCreateStackInstancesCommand(output, context);
    };
    return CreateStackInstancesCommand;
}($Command));
export { CreateStackInstancesCommand };
