import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { CreateStackInstancesInput, CreateStackInstancesOutput } from "../models/models_0";
export interface CreateStackInstancesCommandInput extends CreateStackInstancesInput {
}
export interface CreateStackInstancesCommandOutput extends CreateStackInstancesOutput, __MetadataBearer {
}

export declare class CreateStackInstancesCommand extends $Command<CreateStackInstancesCommandInput, CreateStackInstancesCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: CreateStackInstancesCommandInput;
    constructor(input: CreateStackInstancesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateStackInstancesCommandInput, CreateStackInstancesCommandOutput>;
    private serialize;
    private deserialize;
}
